

CATMULL_SHIFT  equ 8
ROUND equ 8
; procedure drawing textured triangle with Gouraud shading
; Z-buffer alghoritm included, Z coord interpolation ----
; I set the color by this way -- (col1 * col2)/256 ------
;------------------in - eax - x1 shl 16 + y1 ------------
;---------------------- ebx - x2 shl 16 + y2 ------------
;---------------------- ecx - x3 shl 16 + y3 ------------
;---------------------- esi - pointer to Z-buffer--------
;---------------------- edx - pointer to texture---------
;---------------------- Z-buffer filled with dd variables
;---------------------- shifted CATMULL_SHIFT------------
;---------------------- edi - pointer to screen buffer---
;---------------------- xmm0 - lo-> i tex: x1, y2, x2,
;---------------------- 	      y2, x3, y3 as words
;---------------------- xmm5 - horizontal line adress
;---------------------- stack : colors,z ..--------------


tex_plus_grd_triangleA:
; parameters :
   .y_max   equ [ebp+34]
   .y_min   equ [ebp+32]

   .z3	    equ [ebp+30]
   .col3b   equ [ebp+28]
   .col3g   equ [ebp+26]
   .col3r   equ [ebp+24]

   .z2	    equ [ebp+22]
   .col2b   equ [ebp+20]
   .col2g   equ [ebp+18]
   .col2r   equ [ebp+16]

   .z1	    equ [ebp+14]
   .col1b   equ [ebp+12]
   .col1g   equ [ebp+10]
   .col1r   equ [ebp+8]

; local variables:
   .tex_ptr   equ dword[ebp-4]
   .z_ptr     equ dword[ebp-8]
   .scr_buff  equ dword[ebp-12]

   .x1	      equ  word[ebp-14]
   .y1	      equ  word[ebp-16]
   .x2	      equ  word[ebp-18]
   .y2	      equ  word[ebp-20]
   .x3	      equ  word[ebp-22]
   .y3	      equ      [ebp-24]
   .hlp       equ      [ebp-26]

   .dx23      equ  dword[ebp-28]
   .dx12      equ	[ebp-32]
   .dx13      equ	[ebp-36]

   .tex_dy12  equ	[ebp-40]
   .tex_dx12  equ	[ebp-44]
   .dz12      equ  dword[ebp-48]
   .dc12r     equ	[ebp-52]
   .dc12g     equ  dword[ebp-56]
   .dc12b     equ	[ebp-60]

   .tex_dy23  equ	[ebp-64]
   .tex_dx23  equ	[ebp-68]
   .dz23      equ  dword[ebp-72]
   .dc23r     equ	[ebp-76]
   .dc23g     equ  dword[ebp-80]
   .dc23b     equ	[ebp-84]

   .tex_dy13  equ	[ebp-88]
   .tex_dx13  equ	[ebp-92]
   .dz13      equ  dword[ebp-96]
   .dc13r     equ	[ebp-100]
   .dc13g     equ  dword[ebp-104]
   .dc13b     equ	[ebp-108]

   .scan_y1   equ	[ebp-112]
   .scan_x1   equ	[ebp-116]
   .zz1       equ  dword[ebp-120]
   .cur1r     equ	[ebp-124]
   .cur1g     equ	[ebp-128]
   .cur1b     equ	[ebp-132]
   .cur1b_d   equ	[edx]	   ; to achive shorter adresses

   .scan_y2   equ	[ebp-136]
   .scan_x2   equ	[ebp-140]
   .scan_x2_d equ	[edx-8]
   .zz2       equ	[ebp-144]
   .zz2_d     equ	[edx-12]
   .cur2r     equ	[ebp-148]
   .cur2g     equ	[ebp-152]
   .cur2b     equ	[ebp-156]
   .cur2b_d   equ	[edx-24]
   .hline_cal equ	dword[ebp-160]
   .hli_cal_d equ	dword[edx-28]

   .tex_y3    equ [ebp-164]
   .tex_x3    equ [ebp-168]
   .tex_x3_d  equ [edx-36]
   .tex_y2    equ [ebp-170]
   .tex_x2    equ [ebp-172]
   .tex_x2_d  equ [edx-40]
   .tex_y1    equ [ebp-174]
   .tex_x1    equ [ebp-176]
   .tex_x1_d  equ [edx-44]


       push    ebp
       mov     ebp,esp

       push    edx esi edi

   .sort3:
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx

       movups  xmm1, .col1r	  ; exchange r, g, b, z
       movhps  .col1r ,xmm1
       movlps  .col2r ,xmm1
       shufps  xmm0,xmm0,11100001b


 .sort1:
       cmp	bx,cx
       jle	.sort2
       xchg    ebx,ecx

       movups  xmm1, .col2r	  ; exchange r, g, b, z
       movlps  .col3r ,xmm1
       movhps  .col2r ,xmm1
       shufps  xmm0,xmm0,11011000b

       jmp .sort3

 .sort2:


       push	eax	     ; store in variables
       push	ebx
       push	ecx

    ; check was prev - draw_thrd.inc
if 0

	movups	xmm0,.y3		; check if at last only fragment
	pand	xmm0,[draw_thread_mask] ; of triangle is in visable area
	movd	xmm1,.y_min
	packssdw xmm0,xmm0
	pshuflw xmm2,xmm1,01010101b
	pshuflw xmm1,xmm1,0
	movdqa	xmm3,xmm0
	pcmpgtw xmm3,xmm2
	pcmpgtw xmm0,xmm1
	pxor	xmm0,xmm3
	pmovmskb eax,xmm0
	and	al,00111111b
	or	al,al
	jz	.loop2_end

end if


;****************** delta computng zone **************
	  sub	   esp,174 ;7*4
	  lea	    edx,.cur1b
	  movss    .hli_cal_d,xmm5
	  movups   .tex_x1_d,xmm0


	  movups   xmm1,.hlp
	  xorps    xmm0,xmm0

	  psrld    xmm1,16
	  pcmpgtw  xmm0,xmm1
	  pslld    xmm0,16
	  por	   xmm1,xmm0   ; xmm1 lo->hi = y3, y2, y1

	  cvtdq2ps xmm1,xmm1
	  mov	   eax,1 shl 15
	  movaps   xmm2,xmm1
	  shufps   xmm1,xmm1,11000001b
	  shufps   xmm2,xmm2,11100110b
	  cvtsi2ss xmm5,eax
	  subps    xmm1,xmm2
	  shufps   xmm5,xmm5,0
	  rcpps    xmm6,xmm1
	  mulps    xmm5,xmm6
	  cvtps2dq xmm7,xmm5

	  movups   xmm1,.y3
	  xorps    xmm0,xmm0

	  psrld    xmm1,16
	  pcmpgtw  xmm0,xmm1
	  pslld    xmm0,16
	  por	   xmm1,xmm0   ; xmm1 lo->hi = x3, x2, x1

	  cvtdq2ps xmm1,xmm1
	  movaps   xmm2,xmm1
	  shufps   xmm1,xmm1,11000001b
	  shufps   xmm2,xmm2,11100110b

	  subps    xmm1,xmm2
	  mulps    xmm1,xmm5
	  cvtps2dq xmm1,xmm1
	  psrad    xmm1,15 - ROUND



	  movhps   .dx13,xmm1
	  movlps   .dx12,xmm1

;+++++++++++++++++ first zone +++++++++++++

       movaps	 xmm0,xmm7
       pshuflw	 xmm0,xmm0,0
;      shufps	 xmm0,xmm0,0
       movlhps	 xmm0,xmm0
       movlps	 xmm1,.col1r
       movlps	 xmm2,.col2r
       movhps	 xmm1,.tex_x1_d
       movhps	 xmm2,.tex_x2_d
       psubw	 xmm2,xmm1
       movdqa	 xmm3,xmm2
       pmullw	 xmm2,xmm0
       pmulhw	 xmm3,xmm0
       movhlps	 xmm4,xmm2
       movhlps	 xmm5,xmm3
       punpcklwd xmm2,xmm3
       punpcklwd xmm4,xmm5
       psrad	 xmm2,15 - ROUND
       psrad	 xmm4,15 - ROUND
       shufps	 xmm2,xmm2,11000110b
       movups	 .dc12b,xmm2
       movlps	 .tex_dx12,xmm4

;+++++++++++++++++ second zone +++++++++++++

       movaps	 xmm0,xmm7
       shufps	 xmm0,xmm0,01010101b
       pshuflw	 xmm0,xmm0,0
       movlhps	 xmm0,xmm0
       movlps	 xmm1,.col2r
       movlps	 xmm2,.col3r
       movhps	 xmm1,.tex_x2_d
       movhps	 xmm2,.tex_x3_d
       psubw	 xmm2,xmm1
       movdqa	 xmm3,xmm2
       pmullw	 xmm2,xmm0
       pmulhw	 xmm3,xmm0
       movhlps	 xmm4,xmm2
       movhlps	 xmm5,xmm3
       punpcklwd xmm2,xmm3
       punpcklwd xmm4,xmm5
       psrad	 xmm2,15 - ROUND
       psrad	 xmm4,15 - ROUND
       shufps	 xmm2,xmm2,11000110b
       movups	 .dc23b,xmm2
       movlps	 .tex_dx23,xmm4

;++++++++++++++++++third zone++++++++++++++++++++++++
       movhlps	 xmm0,xmm7
    ;	shufps	  xmm0,xmm0,0
       pshuflw	 xmm0,xmm0,0
       movlhps	 xmm0,xmm0
       movlps	 xmm1,.col1r
       movlps	 xmm2,.col3r
       movhps	 xmm1,.tex_x1_d
       movhps	 xmm2,.tex_x3_d
       psubw	 xmm2,xmm1
       movdqa	 xmm3,xmm2
       pmullw	 xmm2,xmm0
       pmulhw	 xmm3,xmm0
       movhlps	 xmm4,xmm2
       movhlps	 xmm5,xmm3
       punpcklwd xmm2,xmm3
       punpcklwd xmm4,xmm5
       psrad	 xmm2,15 - ROUND
       psrad	 xmm4,15 - ROUND
       shufps	 xmm2,xmm2,11000110b
       movups	 .dc13b,xmm2
       movlps	 .tex_dx13,xmm4


; <<<<<<<  ::delta zone end+++++++++++++++++++++ >>>>>>>>


       movsx	 eax,.x1		    ; eax - cur x1
       shl	 eax,ROUND		    ; ebx - cur x2
       mov	 ebx,eax
       lea	 edx,.cur1b
       pxor	 xmm7,xmm7
       movd	 xmm4,.tex_x1_d
       punpcklwd xmm4,xmm7
       pslld	 xmm4,ROUND
       movlps	 .scan_x1,xmm4
       movlps	 .scan_x2_d,xmm4
       movlhps	 xmm4,xmm4


       movq	  xmm0,.col1r
       punpcklwd  xmm0,xmm7
       pslld	  xmm0,ROUND
       shufps	  xmm0,xmm0,11000110b
       movups	  .cur1b_d,xmm0
       movups	  .cur2b_d,xmm0
       movaps	  xmm2,xmm0

       movsx	 edi,word .z1
       shl	 edi,CATMULL_SHIFT
       mov	 .zz1,edi
       mov	 .zz2_d,edi
      ; lea	 edx,.cur1b
       mov	 cx,.y1
       cmp	 cx,.y2
       jge	 .loop1_end
    .loop_1:

       pushad
       push	 dword .y_min
       push	.tex_ptr
       push	.scr_buff
       push	.z_ptr
       push	cx

       sar	eax,ROUND
       sar	ebx,ROUND
       call	.hli_cal_d  ;horizontal_tex_grd_line

       popad

       movups	xmm0,.cur1b_d
       movups	xmm1,.dc13b
       movups	xmm2,.cur2b_d
       movups	xmm3,.dc12b
       movlps	xmm4,.scan_x1
       movhps	xmm4,.scan_x2_d
       movlps	xmm6,.tex_dx13
       movhps	xmm6,.tex_dx12
       paddd	xmm0,xmm1
       paddd	xmm2,xmm3
       paddd	xmm4,xmm6
       movlps	.scan_x1,xmm4
       movhps	.scan_x2_d,xmm4
       movups	.cur1b_d,xmm0
       movups	.cur2b_d,xmm2

       add	eax,.dx13
       add	ebx,.dx12
       inc	cx
       cmp	cx,.y2
       jl      .loop_1
 .loop1_end:
       movzx	ecx,.y2
       cmp	cx,.y3
       jge	.loop2_end

       movsx	ebx,.x2 		   ; eax - cur x1
       shl	ebx,ROUND		   ; ebx - cur x2

       movups	 xmm2,.col2r
       xorps	 xmm0,xmm0
       punpcklwd xmm2,xmm0
       pslld	 xmm2,ROUND
       shufps	 xmm2,xmm2,11000110b
       movups	 .cur2b_d,xmm2

       movlps	 xmm4,.tex_x2_d
       punpcklwd xmm4,xmm0
       pslld	 xmm4,ROUND
       movlps	 .scan_x2_d,xmm4
    ;	movlhps   xmm4,xmm4

       movsx	 edi,word .z2
       shl	 edi,CATMULL_SHIFT
   ;	mov	 .zz1,edx
       mov	 .zz2_d,edi
if 0
       movzx	edi,word .col2r
       shl	edi,ROUND
   ;	mov	 .cur1r,edi
       mov	.cur2r,edi

       movzx	esi,word .col2g
       shl	esi,ROUND
   ;	mov	 .cur1g,esi
       mov	.cur2g,esi

       movzx	edx,word .col2b
       shl	edx,ROUND
   ;	mov	 .cur1b,edx
       mov	.cur2b,edx
end if

       movups	xmm0,.cur1b_d
;      movups	xmm1,.dc13b
       movups	xmm2,.cur2b_d
;      movups	xmm3,.dc12b
       movlps	xmm4,.scan_x1
       movhps	xmm4,.scan_x2_d


  .loop_2:
       pushad
       push	 dword .y_min
       push	 .tex_ptr
       push	 .scr_buff
       push	 .z_ptr
       push	 cx


       sar	 eax,ROUND
       sar	 ebx,ROUND
       call	 .hli_cal_d ;horizontal_tex_grd_line

       popad

       movups	 xmm0,.cur1b_d
       movups	 xmm1,.dc13b
       movups	 xmm2,.cur2b_d
       movups	 xmm3,.dc23b
       movlps	 xmm4,.scan_x1
       movhps	 xmm4,.scan_x2_d
       movlps	 xmm6,.tex_dx13
       movhps	 xmm6,.tex_dx23

       paddd	xmm0,xmm1
       paddd	xmm2,xmm3
       paddd	xmm4,xmm6

       movlps	.scan_x1,xmm4
       movhps	.scan_x2_d,xmm4
       movups	.cur1b_d,xmm0
       movups	.cur2b_d,xmm2

       add	eax,.dx13
       add	ebx,.dx23
       inc	cx
       cmp	cx,.y3
       jl	.loop_2

.loop2_end:

       mov	esp,ebp
       pop	ebp

ret 28


horizontal_tex_grd_line:

;in:
; xm0 - b1 g1 r1 z1 as dword integer
; xm2 - b2 g2 r2 z2 as dword integer
; xm4 - lo -> hi = tx1, ty1, tx2, ty2 as dword int
; eax - x1, ebx - x2, stack other params

.y_max	  equ [ebp+20]
.y_min	  equ [ebp+18]
.tex_ptr  equ [ebp+14]
.screen   equ [ebp+10]
.z_buffer equ [ebp+6]
.y	  equ word[ebp+4]


.x1 equ  word[ebp-2]
.x2 equ  word[ebp-4]
.dz equ dword[ebp-8]
.db equ [ebp-12]
.dg equ dword[ebp-16]
.dr equ [ebp-20]
.dtex_x equ dword[ebp-24]
.dtex_y equ [ebp-28]

.z2	equ [ebp-32]
.b2	equ [ebp-36]
.g2	equ [ebp-40]
.r2	equ [ebp-44]

.z1	equ [ebp-48]
.b1	equ [ebp-52]
.g1	equ [ebp-56]
.r1	equ [ebp-60]

.tex_x2 equ [ebp-64]
.tex_y2 equ [ebp-68]
.tex_x1 equ [ebp-72]
.tex_y1 equ [ebp-76]


	mov	ebp,esp

	movsx	ecx, .y
	cmp	cx,.y_min

	jl	.quit_l

	cmp	cx,.y_max
	jge	.quit_l

	cmp	ax,bx
	je	.quit_l
	jl	@f

	movaps	xmm7,xmm0
	movaps	xmm3,xmm4
	movaps	xmm0,xmm2
	movhlps xmm4,xmm4
	movaps	xmm2,xmm7
	movlhps xmm4,xmm3
	xchg	eax,ebx


    @@:
	or	bx,bx
	jle	.quit_l
	cmp	ax,[xres_var]	 ;SIZE_X
	jge	.quit_l
	shufps	xmm4,xmm4,10110001b

	push	ax
	push	bx
	sub	esp,80

	movups	.r2,xmm2
	movups	.r1,xmm0
	movups	.tex_y1,xmm4

	mov	bx,.x2
	sub	bx,.x1

	movsx	 ebx,bx
	mov	 eax,1 shl 14
	cdq
	idiv	 ebx
	mov	 ebx,eax

	mov	eax,.z2 	   ; delta zone************
	sub	eax,.z1
	imul	ebx
	sar	eax,14
	mov	.dz,eax  ; .dz

	mov	eax,.b2
	sub	eax,.b1
	imul	ebx
	sar	eax,14
	mov	.db,eax

	mov	eax,.g2
	sub	eax,.g1
	imul	ebx
	sar	eax,14
	mov	.dg,eax

	mov	eax,.r2
	sub	eax,.r1
	imul	ebx
	sar	eax,14
	mov	.dr,eax

	mov	eax,.tex_x2
	sub	eax,.tex_x1
	imul	ebx
	sar	eax,14
	mov	.dtex_x,eax


	mov	eax,.tex_y2
	sub	eax,.tex_y1
	imul	ebx
	sar	eax,14
	mov	.dtex_y,eax


if 0
       sub	 esp,6*4
       movd	 xmm0,ebx
       pshuflw	 xmm0,xmm0,0
       movlhps	 xmm0,xmm0
       movdqu	 xmm1,.tex_y1
       movdqu	 xmm2,.tex_y2
       movq	 xmm3,.b1
       movq	 xmm4,.b2
       psubd	 xmm4,xmm3
       psubd	 xmm2,xmm1
       packssdw  xmm2,xmm4
  ;	packlssdw  xmm2,xmm2
   ;	movlhps   xmm2,xmm4


   ;	psubw	  xmm2,xmm1
       movdqa	 xmm3,xmm2
       pmullw	 xmm2,xmm0
       pmulhw	 xmm3,xmm0
       movhlps	 xmm4,xmm2
       movhlps	 xmm5,xmm3
       punpcklwd xmm2,xmm3
       punpcklwd xmm4,xmm5
       psrad	 xmm2,14 - ROUND
       psrad	 xmm4,14 - ROUND
   ;	pshufd	  xmm2,xmm2,11000110b
       movdqu	 .dtex_y,xmm2
       movq	 .db,xmm4


end if

	cmp	.x1,0
	jg	@f

	mov	eax,.dz     ; clipping
	movsx	ebx,.x1
	neg	ebx
	imul	ebx
	add	.z1,eax
	mov	.x1,0

	mov	eax,.dr
	imul	ebx
	add	.r1,eax

	mov	eax,.dg
	imul	ebx
	add	.g1,eax

	mov	eax,.db
	imul	ebx
	add	.b1,eax

	mov	eax,.dtex_x
	imul	ebx
	add	.tex_x1,eax

	mov	eax,.dtex_y
	imul	ebx
	add	.tex_y1,eax
   @@:
	movsx	  edx,[xres_var]
	cmp	  .x2,dx
	jl	  @f
	mov	  .x2,dx
    @@:
; calc line addres begin in screen and Z buffer
	movsx	  eax, .y
	mul	  edx
	movsx	  edx,.x1
	add	  eax,edx

	mov	  esi,eax
	shl	  esi,2
	add	  esi,.z_buffer

	shl	  eax,2
	mov	  edi,.screen
	add	  edi,eax

	mov	  cx,.x2
	sub	  cx,.x1
	movzx	  ecx,cx

; init current variables
	movdqu	  xmm0,.r1
	movdqu	  xmm1,.dr
	pxor	  xmm2,xmm2
	movq	  xmm4,.dtex_y
	movq	  xmm5,.tex_y1

	mov	  ebx,.z1
      .ddraw:
	cmp	  ebx,dword[esi]
	jge	  @f
	movdqa	  xmm6,xmm5
	psrld	  xmm6,ROUND
	movd	  eax,xmm6
	psrldq	  xmm6,4
	movd	  edx,xmm6
	shl	  eax,TEX_SHIFT

   ; calc texture pixel mem addres

       add	 eax,edx
       and	 eax,TEXTURE_SIZE   ; cutting
       shl	 eax,2
       add	 eax,.tex_ptr
       mov	 dword[esi],ebx

       movd	 xmm7,[eax]
       punpcklbw xmm7,xmm2
       movdqa	 xmm3,xmm0   ; calc col
       psrld	 xmm3,ROUND  ;
       packssdw  xmm3,xmm3
       pshuflw	 xmm3,xmm3,11000110b
       pmullw	 xmm7,xmm3
       psrlw	 xmm7,8
       packuswb  xmm7,xmm7
       movd	 [edi],xmm7
       mov	  dword[esi],ebx
     @@:
       add	  edi,4
       add	  esi,4
       add	  ebx,.dz
       paddd	  xmm5,xmm4
       paddd	  xmm0,xmm1

       loop	.ddraw

  .quit_l:
	mov	esp,ebp

ret 18	; horizontal line

