; Line drawing procedure by Pablo Reda.
; Gouraud/Texture extension by Maciej Guba.
;****************************************************
line_grd_tex:  ; eax=x1 ebx=y1 ecx=x2 edx=y2
		 ; xmm0 - color1 argb as 4 dword float
		 ; xmm1 - color2 argb as 4 dword float
		 ; xmm2 - z1 as dword  float
		 ; xmm3 - z2 as dword  float
		 ; xmm7 - max x, max y
		 ; xmm6 - min x, min y
		 ; edi - horizontal line adress

		 ; xmm5  - parameters pack: Z buffer,  screen buffer,
		 ;	   screen width, texture ptr, as dword integer
		 ;	   lo -> hi: wid, texptr , zbuff, screen_ptr

	push	  ebp
	mov	  ebp,esp
	sub	  esp,20
						  ; xm5 lo(.wid) -> hi(.scr)
	.scr	  equ [ebp-4]			  ; .scr
	.zbuff	  equ [ebp-8]			  ; .zbu
	.tex_ptr  equ [ebp-12]			  ; .linetexptr
	.width	  equ [ebp-16]			  ; .width
	.h_line   equ dword[ebp-20]
	cld
	mov	  .h_line,edi
	movups	 .width,xmm5

	cmp	 ebx,edx
	jg	 .noswap
  ;	 jne	  @f
  ;	 call	  .h_line
  ;    @@:
	xchg	 eax,ecx
	xchg	 ebx,edx
	movaps	 xmm5,xmm0
	movaps	 xmm0,xmm1
	movaps	 xmm1,xmm5
	movaps	 xmm5,xmm2
	movaps	 xmm2,xmm3
	movaps	 xmm3,xmm5
.noswap:
	sub	 esp,16
	movlhps  xmm7,xmm6
	movups	 [esp],xmm7

	push	 eax ebx ecx edx
	movups	 xmm7,[esp]
	cvtdq2ps xmm7,xmm7
	movhlps  xmm6,xmm7
	subps	 xmm7,xmm6

	andps	 xmm7,[abs_mask]  ; 0x7fff
	add	 esp,16

	movaps	 xmm6,xmm7
	shufps	 xmm6,xmm6,01010101b
	maxss	 xmm7,xmm6   ; xmm7 - delta
	shufps	 xmm7,xmm7,0
	movaps	 xmm6,xmm3
	rcpps	 xmm7,xmm7
	subss	 xmm6,xmm2
	mulss	 xmm6,xmm7   ; xmm6 - delta z
	movaps	 xmm5,xmm1
	subps	 xmm5,xmm0
	mulps	 xmm5,xmm7   ; xmm5 - delta col argb

	movups	 xmm3,[esp]
	movhlps  xmm4,xmm3
	add	 esp,16
	pshufd	 xmm4,xmm4,00000101b  ; xm4 - lo hi -> min x  min x miny miny
	pshufd	 xmm3,xmm3,00000101b  ; xm3 - lo hi -> max x  max x maxy maxy



	shl  eax,16
	shl  ecx,16
	sub  eax,ecx
	push ebx
	push edx
	sub  ebx,edx
	inc  ebx
	cdq
	idiv ebx
	mov  esi,eax
	neg  cx
     ;	 add  ecx,$7fff
	pop  ebx
	pop  edx
.lineas:
	mov  eax,ecx
	add  eax,esi
	push ebx
	push eax
	push edx
	shr  ecx,16
	shr  eax,16
	call .h_line  ;.horizontal_grd
	pop  edx
	pop  ecx
	pop  ebx
	inc  ebx
	cmp  ebx,edx
	jle  .lineas
	leave
	ret

horizontal_grd:  ; eax=x1 ebx=y1 ecx=x2

	.scr	  equ [ebp-4]			  ; .scr
	.zbuff	  equ [ebp-8]			  ; .zbu
	.tex_ptr  equ [ebp-12]			  ; .linetexptr
	.width	  equ [ebp-16]			  ; .width

	push	 eax ecx ebx ebx
	movdqu	 xmm7,[esp]
	movdqa	 xmm1,xmm7
	add	 esp,16
	pcmpgtd  xmm1,xmm4
	pcmpgtd  xmm7,xmm3

	pxor	 xmm7,xmm1
	pmovmskb edi,xmm7    ; clipping
	cmp	 di,0xffff
	jnz	 .en

	cmp	 ecx,eax
	jg	 .m
	xchg	 ecx,eax
.m:
	sub	 ecx,eax
	jnz	 .nn
	inc	 ecx
.nn:
	imul	 ebx,.width
	add	 eax,ebx
	mov	 edi,.scr
	lea	 edi,[edi+eax*4]
	push	 eax
	push	 ebx
	mov	 ebx,.zbuff
	lea	 ebx,[ebx+eax*4]
.l:
	movaps	 xmm7,xmm2     ; xmm2 - cur z
	cmpnltss xmm7,[ebx]
	movd	 eax,xmm7
	or	 eax,eax
	jnz	 @f
	movaps	 xmm7,xmm0    ; xmm0 - cur col
	cvtps2dq xmm7,xmm7
	packssdw xmm7,xmm7
	packuswb xmm7,xmm7
	movd	 [edi],xmm7
      @@:
	addss	 xmm2,xmm6
	addps	 xmm0,xmm5
	add	 edi,4
	loop	 .l
	pop	 ebx
	pop	 eax
      .en:
	ret

horizontal_tx:	; eax=x1 ebx=y1 ecx=x2

	.scr	  equ [ebp-4]			  ; .scr
	.zbuff	  equ [ebp-8]			  ; .zbu
	.tex_ptr  equ [ebp-12]			  ; .linetexptr
	.width	  equ [ebp-16]			  ; .width

	push	 eax ecx ebx ebx
	movdqu	 xmm7,[esp]
	movdqa	 xmm1,xmm7
	add	 esp,16
	pcmpgtd  xmm1,xmm4
	pcmpgtd  xmm7,xmm3

	pxor	 xmm7,xmm1
	pmovmskb edi,xmm7    ; clipping
	cmp	 di,0xffff
	jnz	 .en1
	cmp	 ecx,eax
	jg	 .m
	xchg	 ecx,eax
.m:

	sub	 ecx,eax
	jnz	 .nn
	inc	  ecx
.nn:

	imul	 ebx,.width
	add	 eax,ebx
	mov	 edi,.scr
	lea	 edi,[edi+eax*4]
	push	 eax
	push	 ebx
	mov	 ebx,.zbuff
	lea	 ebx,[ebx+eax*4]
.l:
	movaps	 xmm7,xmm2     ; xmm2 - cur z
	cmpnltss xmm7,[ebx]
	movd	 eax,xmm7
	or	 eax,eax
	jnz	 @f
	movss	 [ebx],xmm2
	movaps	 xmm7,xmm0    ; xmm0 - cur col
	cvtps2dq xmm7,xmm7
    ;	 xmm7  - cur tex coord

	movd	 eax,xmm7
	psrldq	 xmm7,4
	movd	 edx,xmm7
	shl	 eax,TEX_SHIFT
	add	 eax,edx
	shl	 eax,2
	and	 eax,TEXTURE_SIZE

	mov	 edx,.tex_ptr
	mov	 eax,[eax+edx]
	mov	 [edi],eax
      @@:
	add	 edi,4
	add	 ebx,4
	addps	 xmm0,xmm5
	addps	 xmm2,xmm6
	loop	 .l
	pop	 ebx
	pop	 eax
       .en1:
	ret



plain_horizontal:  ; eax=x1 ebx=y1 ecx=x2
	.scr	  equ [ebp-4]			  ; .scr
	.zbuff	  equ [ebp-8]			  ; .zbu
	.tex_ptr  equ [ebp-12]			  ; .linetexptr
	.width	  equ [ebp-16]			  ; .width

	push	 eax ecx ebx ebx

	movdqu	 xmm7,[esp]
	movdqa	 xmm1,xmm7
	add	 esp,16
	pcmpgtd  xmm1,xmm4
	pcmpgtd  xmm7,xmm3
	pxor	 xmm7,xmm1
	pmovmskb edi,xmm7    ; clipping
	cmp	 di,0xffff
	jnz	 .l
	cmp	 ecx,eax
	jg	 .m
	xchg	 ecx,eax
.m: 
	sub	 ecx,eax
	jnz	 .nn
	inc	 ecx
.nn:
	imul	 ebx,.width
	add	 eax,ebx
	mov	 edi,.scr
	lea	 edi,[edi+eax*4]
	mov	 eax,.tex_ptr  ; xm3 - col
	rep	 stosd
.l:
	ret

