


; Line drawing procedure by Pablo Reda.
; Some changes by Maciej Guba.
;******************************************* 

linea:	    ; sse version
            ; I avoid use mmx reg

	    ; eax=x1 ebx=y1 ecx=x2 edx=y2
	    ; xmm1  - screen buffer
	    ; xmm2  - screen width
	    ; xmm3  - color 0x00rrggbb
	    ; xmm7  - max x, max y
	    ; xmm6  - min x, min y

   ;	 push	   ebp
   ;	 mov	   ebp,esp
   ;	a sub	    esp,16

	pshufd	 xmm6,xmm6,00000101b  ; xm4 - lo hi -> min x  min x miny miny
	pshufd	 xmm7,xmm7,00000101b  ; xm3 - lo hi -> max x  max x maxy maxy
	cld
	movaps	 xmm4,xmm6
     ;	 movaps   xmm3,xmm7
	cmp  ebx,edx
     ;	 je   hhorizontalB
	jg   .noswap
	xchg eax,ecx 
	xchg ebx,edx 
.noswap:
	cmp  eax,ecx
	shl  eax,16
	shl  ecx,16
	sub  eax,ecx
	push ebx 
	push edx 
	sub  ebx,edx
	inc  ebx
	cdq 
	idiv ebx 
	mov  esi,eax
	add  ecx,$7fff
	pop  ebx
	pop  edx
.lineas: 
	mov  eax,ecx
	add  eax,esi
	push ebx 
	push eax 
	shr  ecx,16
	shr  eax,16
	call hhorizontalB
	pop  ecx
	pop  ebx
	inc  ebx
	cmp  ebx,edx
	jle  .lineas
.end:
     ;	 leave
	ret

hhorizontalB:  ; eax=x1 ebx=y1 ecx=x2

	push	 eax ecx ebx ebx
	movdqu	 xmm0,[esp]
	movdqa	 xmm4,xmm0
	add	 esp,16
	pcmpgtd  xmm0,xmm7
	pcmpgtd  xmm4,xmm6
	pxor	 xmm0,xmm4
	pmovmskb edi,xmm0    ; clipping
	cmp	 di,0xffff
	jnz	 .l
	cmp	 ecx,eax
	jg	 .m
	xchg	 ecx,eax
.m: 
	sub   ecx,eax
	jnz   .nn
	inc   ecx
.nn:
	push  edx
	movd  edx,xmm2
	imul  ebx,edx	 ; xmm2 - screen_width_var
	pop   edx
	add   eax,ebx
	movd  edi,xmm1	 ; xmm1 - line_buffer_var
	lea   edi,[edi+eax*4]
	movd  eax,xmm3	 ; xm3 - col
	rep   stosd
.l:
	ret

